* Program-ID...:  BuildXMLHierarchy.PRG
CLOSE ALL
CLEAR ALL
CLEAR
USE Invoices IN A
USE INVDETL IN B
lcXML = ""
Add2XML ( [<?xml version = "1.0" encoding="Windows-1252" standalone="yes"?>] )
SELECT Invoices
Add2XML ( [<Invoices>] )
NoFac = 0
SCAN
  NoFac = NoFac + 1
  Add2XML ( [<Invoice] + TRANSFORM(NoFac) + [>], 1 )
  FOR I = 1 TO FCOUNT()
    fld = LOWER(FIELD(I))
    Add2XML ( [<]  + fld + [>] + ALLTRIM(TRANSFORM(EVALUATE(fld))) ;
 + [</] + fld + [>], 2)
  ENDFOR
  SELECT INVDETL
  SET FILTER TO INVNUM = InvoiceS.INVNUM
  NoLine = 0
  SCAN
    NoLine = NoLine + 1
    Add2XML ( [<Line] + TRANSFORM(NoLine) + [>], 2 )
    FOR I = 1 TO FCOUNT()
      fld = LOWER(FIELD(I))
      Add2XML ([<]  + fld + [>] + ALLTRIM(TRANSFORM(EVALUATE(fld))) ;
  + [</] + fld + [>], 3)
    ENDFOR
    Add2XML ( [</Line] + TRANSFORM(NoLine) + [>], 2 )
  ENDSCAN
  SELECT Invoices
  Add2XML ( [</Invoice]   + TRANSFORM(NoFac) + [>], 1 )
ENDSCAN
Add2XML ( [</Invoices>] )
STRTOFILE( lcXML, "TEST.XML" )
MODIFY FILE TEST.XML NOMODIFY

FUNCTION Add2XML
PARAMETERS Texto, Indent
Indent = IIF ( EMPTY ( Indent ), 0, Indent )
lcXML = lcXML + IIF(EMPTY(lcXML),"",CHR(13)) + REPLICATE(CHR(9),Indent) + Texto
RETURN