Imports System.Data.SqlClient

Public Class DataAccessClass

    Public conn As New SqlConnection("Server=localhost;Database=Northwind;UID=sa;PWD=;")
    Dim ds As DataSet

    Public Function GetRecord( _
      ByVal pTable As String, ByVal _
      pKeyField As String, _
      ByVal pKeyValue As String) _
     As DataSet
        Dim cmd As String = "SELECT * FROM " + pTable + " WHERE " + pKeyField + "=" + pKeyValue
        Dim da As New SqlDataAdapter(cmd, conn)
        da.Fill(ds)
        Return ds
    End Function

    Public Function SaveRecord(ByVal pCmd As String) As String
        Dim Result As String = "Ok"
        Try
            Dim sc As New SqlCommand(pCmd, conn)
            sc.CommandType = CommandType.Text
            sc.ExecuteNonQuery()
        Catch oEx As Exception
            Result = "Update failed"
        End Try
        Return Result
    End Function

    Public Function GetKeys( _
      ByVal pTopRecord As String, _
      ByVal pTable As String, _
      ByVal pKeyField As String, _
      ByVal pNumRecs As Integer) _
     As Array
        Dim cmd As String
        Dim al(pNumRecs) As String
        Dim WhereClause As String = ""
        If pTopRecord = "" Then
            WhereClause = " WHERE " + pKeyField + "<=" + pTopRecord
        End If
        cmd = "SELECT TOP " + pNumRecs.ToString + pKeyField _
            + " FROM " + pTable _
            + WhereClause _
            + " ORDER BY " + pKeyField + " DESC"
        Dim da As New SqlDataAdapter(cmd, conn)
        da.Fill(ds)
        Dim dr As DataRow
        Dim I As Integer = 0
        For Each dr In ds.Tables(0).Rows
            al(I) = dr(0)
            I += 1
        Next
        Return al
    End Function

End Class