SET TALK OFF
SET CONFIRM ON
SET PATH TO ( HOME() + [Samples\data\] )

mCountry = INPUTBOX("Country to include?","Leave blank to include all countries, ESC to cancel","")

IF LASTKEY() = 27
   RETURN
ENDIF

mCountry = PROPER( mCountry )

SELECT ;
  ORDERS.Order_Amt,						;
  Customer.Company, 					;
  Customer.Region,						;
  Customer.Country						;
FROM ORDERS, CUSTOMER					;
WHERE ORDERS.Cust_ID = CUSTOMER.Cust_ID ;
AND Country = mCountry					;
ORDER BY								;
  Customer.Country,						;
  Customer.Region,						;
  Customer.Company						;
 INTO CURSOR C1

*!*	BROWSE
*!*	IF LASTKEY() = 27
*!*	   RETURN
*!*	ENDIF
 
IF RECCOUNT() = 0
   MESSAGEBOX( "No records found for " + mCountry, 64, "No matching records found", 5000 )
   USE IN C1
   RETURN
ENDIF

SET TEXTMERGE ON TO C:\inetpub\wwwroot\CustsByCountry.HTM NOSHOW

\<html><head><title>Customers by country</title></head>
\<body>
\<table>
\ <tr><td width="100">
\   <table><tr><td size="1"><<DTOC(DATE())  >></td></tr>
\          <tr><td size="1"><<LEFT(TIME(),5)>></td></tr>
\   </table>
\     <td width="600" size="4" align="center" valign="top">Orders by Country</td>
\     <td width="100" size="1" valign="top">Page 1</td>
\ </tr>
\<table>

LastRegion  = "X"
LastCountry = "X"

\<table>
SCAN

    IF Region <> LastRegion
       \<tr><td>Region: <<Region>></td></tr>
    ENDIF

    IF Country <> LastCountry
       \<tr><td>Country: <<Country>></td></tr>
    ENDIF

* Each row in the table is another small two-column table
    \<tr><td><table><tr><td width="80%"><<Company>></td>
    \                   <td width="20%" align="right"><<TRANSFORM(Order_Amt,"#,###,###.##")>></td>
    \               </tr>
    \        </table></td>
    \</tr>

    LastCountry = Country
    LastRegion  = Region

ENDSCAN
\</table>

USE

SET TEXTMERGE TO