Imports System.IO

Public Class DataAccessFileManager

    Public FileName As String = CurDir() + "\Config.txt"
    Public ConnString As String

    Public Sub WriteFile()
        Dim myStreamWriter As StreamWriter
        Try
            FileName = CurDir() + "\Config.txt"
            myStreamWriter = File.CreateText(FileName)
            myStreamWriter.Write(ConnString)
            myStreamWriter.Flush()
        Catch exc As Exception
            MsgBox("File could not be created or written to." + vbCrLf + _
                "Please verify that the filename is correct, " + _
                "and that you have write permissions for the desired " + _
                "directory." + vbCrLf + vbCrLf + "Exception: " + exc.Message)
        Finally
            If Not myStreamWriter Is Nothing Then
                myStreamWriter.Close()
            End If
        End Try
    End Sub

    Public Sub ReadFile()
        Dim myStreamReader As StreamReader
        Try
            FileName = CurDir() + "\Config.txt"
            myStreamReader = File.OpenText(FileName)
            ConnString = myStreamReader.ReadLine()
        Catch exc As Exception
            ConnString = "Server=(local);database=Pinter;UID=sa;PWD=;"
        Finally
            If Not myStreamReader Is Nothing Then
                myStreamReader.Close()
            End If
        End Try
    End Sub

End Class