Imports System.ComponentModel

Public Class SearchForm
    Inherits System.Windows.Forms.Form

    Private _SearchField As String
    Private _KeyField As String
    Private _TableName As String
    Private _FieldList As String = "*"
    Private _Delim As String = ""

    Public KeyValue As String = ""
    Public ConnStr As String
    Public SearchForm As Object
    Public ds As New DataSet
    Public dv As New DataView

    <Category("*My properties")> Public Property Delim() As String
        Get
            Return _Delim
        End Get
        Set(ByVal Value As String)
            _Delim = Value
        End Set
    End Property

    <Category("*My properties")> Public Property FieldList() As String
        Get
            Return _FieldList
        End Get
        Set(ByVal Value As String)
            _FieldList = Value
        End Set
    End Property

    <Category("*My properties")> Public Property SearchField() As String
        Get
            Return _SearchField
        End Get
        Set(ByVal Value As String)
            _SearchField = Value
            Label1.Text = "Show records in which the " + SearchField + " field contains"
        End Set
    End Property

    <Category("*My properties")> Public Property KeyField() As String
        Get
            Return _KeyField
        End Get
        Set(ByVal Value As String)
            _KeyField = Value
        End Set
    End Property

    <Category("*My properties")> Public Property TableName() As String
        Get
            Return _TableName
        End Get
        Set(ByVal Value As String)
            _TableName = Value
        End Set
    End Property

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Public MyText1 As FormControls.MyText
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    Friend WithEvents cmdShowMatches As System.Windows.Forms.Button
    Public WithEvents cmdSelect As System.Windows.Forms.Button
    Public WithEvents cmdCancel As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label
        Me.MyText1 = New FormControls.MyText
        Me.cmdShowMatches = New System.Windows.Forms.Button
        Me.DataGrid1 = New System.Windows.Forms.DataGrid
        Me.cmdSelect = New System.Windows.Forms.Button
        Me.cmdCancel = New System.Windows.Forms.Button
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(288, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Show records in which the xxx field contains"
        '
        'MyText1
        '
        Me.MyText1.BackColor = System.Drawing.Color.White
        Me.MyText1.Enabled = False
        Me.MyText1.Location = New System.Drawing.Point(312, 6)
        Me.MyText1.Name = "MyText1"
        Me.MyText1.Size = New System.Drawing.Size(72, 20)
        Me.MyText1.TabIndex = 1
        Me.MyText1.Text = ""
        '
        'cmdShowMatches
        '
        Me.cmdShowMatches.Location = New System.Drawing.Point(392, 5)
        Me.cmdShowMatches.Name = "cmdShowMatches"
        Me.cmdShowMatches.Size = New System.Drawing.Size(88, 23)
        Me.cmdShowMatches.TabIndex = 2
        Me.cmdShowMatches.Text = "Show matches"
        '
        'DataGrid1
        '
        Me.DataGrid1.AlternatingBackColor = System.Drawing.Color.Silver
        Me.DataGrid1.BackColor = System.Drawing.Color.White
        Me.DataGrid1.CaptionBackColor = System.Drawing.Color.Maroon
        Me.DataGrid1.CaptionFont = New System.Drawing.Font("Tahoma", 8.0!)
        Me.DataGrid1.CaptionForeColor = System.Drawing.Color.White
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.Font = New System.Drawing.Font("Tahoma", 8.0!)
        Me.DataGrid1.ForeColor = System.Drawing.Color.Black
        Me.DataGrid1.GridLineColor = System.Drawing.Color.Silver
        Me.DataGrid1.HeaderBackColor = System.Drawing.Color.Silver
        Me.DataGrid1.HeaderFont = New System.Drawing.Font("Tahoma", 8.0!)
        Me.DataGrid1.HeaderForeColor = System.Drawing.Color.Black
        Me.DataGrid1.LinkColor = System.Drawing.Color.Maroon
        Me.DataGrid1.Location = New System.Drawing.Point(10, 41)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.ParentRowsBackColor = System.Drawing.Color.Silver
        Me.DataGrid1.ParentRowsForeColor = System.Drawing.Color.Black
        Me.DataGrid1.ReadOnly = True
        Me.DataGrid1.SelectionBackColor = System.Drawing.Color.Maroon
        Me.DataGrid1.SelectionForeColor = System.Drawing.Color.White
        Me.DataGrid1.Size = New System.Drawing.Size(475, 198)
        Me.DataGrid1.TabIndex = 3
        '
        'cmdSelect
        '
        Me.cmdSelect.Location = New System.Drawing.Point(196, 246)
        Me.cmdSelect.Name = "cmdSelect"
        Me.cmdSelect.Size = New System.Drawing.Size(49, 23)
        Me.cmdSelect.TabIndex = 4
        Me.cmdSelect.Text = "&Select"
        '
        'cmdCancel
        '
        Me.cmdCancel.Location = New System.Drawing.Point(248, 246)
        Me.cmdCancel.Name = "cmdCancel"
        Me.cmdCancel.Size = New System.Drawing.Size(49, 23)
        Me.cmdCancel.TabIndex = 5
        Me.cmdCancel.Text = "&Cancel"
        '
        'SearchForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(492, 273)
        Me.ControlBox = False
        Me.Controls.Add(Me.cmdCancel)
        Me.Controls.Add(Me.cmdSelect)
        Me.Controls.Add(Me.DataGrid1)
        Me.Controls.Add(Me.cmdShowMatches)
        Me.Controls.Add(Me.MyText1)
        Me.Controls.Add(Me.Label1)
        Me.Name = "SearchForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Search Form"
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim DataAccess As New DataAccessManager.DataAccessFileManager
        DataAccess.ReadFile()
        ConnStr = DataAccess.ConnString
        DataAccess = Nothing
        ' Assign searchform here
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdShowMatches.Click

        Dim cn As New SqlClient.SqlConnection
        cn.ConnectionString = ConnStr
        cn.Open()

        Dim cmd As New SqlClient.SqlCommand
        cmd.CommandText = "SELECT * FROM " + TableName _
                        + " WHERE " + SearchField + " LIKE '" _
                        + MyText1.Text.ToUpper.Trim + "%'"

        cmd.Connection = cn

        'cmd.CommandText = "SELECT Count(*) FROM " + TableName + " WHERE " + SearchField + " LIKE '" + MyText1.Text.ToUpper.Trim + "%'"
        'Dim HowMany As Integer
        'HowMany = cmd.ExecuteScalar
        'If HowMany > MaxRecords Then
        '    If MsgBox("This query will return " + HowMany.ToString + " records. Proceed?", MsgBoxStyle.Exclamation, Application.ProductName) = MsgBoxResult.No Then
        '        Return
        '    End If
        'End If

        Dim da As New SqlClient.SqlDataAdapter
        da.SelectCommand = cmd

        ds.Clear()
        da.Fill(ds, TableName)
        dv = ds.Tables(0).DefaultView

        DataGrid1.DataSource = dv

    End Sub

    Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
        KeyValue = Delim + Delim
        Hide()
    End Sub

    Private Sub cmdSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSelect.Click
        KeyValue = Delim + dv(DataGrid1.CurrentRowIndex)(KeyField).ToString + Delim
        Hide()
    End Sub

End Class
