* MakeSQLTables
* Creates SQL tables using local DBF structure

CLOSE ALL
CLEAR ALL
=SQLDISCONNECT(0)

strConnect = [Driver={SQL Server};Server=(local);Database=Pinter;UID=sa;pwd=;]
lh = SQLSTRINGCONNECT( strConnect )
IF lh <= 0
   MESSAGEBOX( "Couldn't connect to SQL Server", 64, _VFP.Caption )
   RETURN
ENDIF
USE TabList
SCAN FOR Access = [SQL]
	SELECT 0
	USE ( TabList.TableName )
	AFIELDS(Flds)
	Tbl = ALIAS()
	cmd = [CREATE TABLE ] + Tbl + [ ( ]
	FOR I = 1 TO ALEN(Flds,1)
		Fld = Flds(I,1)
		Typ = Flds(I,2)
		DO CASE
		   CASE Typ = [C]
				Typ = [Char(] + TRANSFORM(Flds(I,3))+[) NOT NULL DEFAULT '']
		   CASE Typ $ [DT]
				Typ = [DateTime NOT NULL DEFAULT '']
		   CASE Typ = [I]
				Typ = [Integer NOT NULL DEFAULT 0]
		   CASE Typ = [N]
				Typ = [Numeric(] + TRANSFORM(Flds(I,3)) + [,] + TRANSFORM(Flds(I,4)) + [) NOT NULL DEFAULT 0]
		   CASE Typ = [L]
				Typ = [Bit NOT NULL DEFAULT 0]
		   CASE Typ = [M]
				Typ = [Text NOT NULL DEFAULT '']
		ENDCASE
		Cmd = Cmd + Fld + [ ] + Typ + [, ] + CHR(13)
	ENDFOR
	Cmd = LEFT(Cmd,LEN(Cmd)-3) + [ )]
	USE
	SELECT TabList
	lr = SQLEXEC( lh, Cmd )
	IF lr < 0
	   ? [Table ] + Tbl + [ not created]
	ENDIF
ENDSCAN
=SQLDISCONNECT(0)