CREATE CLASS ComplexMenuItem OF Pinter AS Container

DEFINE CLASS menuitem AS editbox


	Height = 18
	ScrollBars = 0
	SpecialEffect = 1
	Width = 136
	BorderColor = RGB(255,255,255)
	activecolor = (RGB(255,0,0))
	droppable = .F.
	Name = "menuitem"
	inactivecolor = .F.


	PROCEDURE Click
		IF THIS.Name <> [Bar]
		   RETURN
		ENDIF
		IF THIS.Droppable
			WITH THISFORM
			DIMENSION oList ( .Objects.Count )
			FOR I = 1 TO	  .Objects.Count
				oList ( I ) = .Objects(I).Name
			ENDFOR
			FOR I = 1 TO ALEN ( oList )
				IF oList(I) = [Bar] AND oList(I) <> THIS.Name
				   .RemoveObject ( oList(I) )
				ENDIF
			ENDFOR
			ENDWITH
			FOR I = THIS.Top TO THIS.Parent.Height - THIS.Height STEP 10
				a=INKEY(.02)
				THIS.Top = I
			ENDFOR
			a=INKEY(.1)
			THIS.Visible = .F.
		ENDIF
		ActionNum = VAL ( RIGHT ( THIS.Name, 1 ) )
		Cmd = THISFORM.JavaMenu1.Menu ( ActionNum, 2 )
		&Cmd
		IF THIS.Droppable
		   THISFORM.RemoveObject ( THIS.Name )
		ENDIF
	ENDPROC


	PROCEDURE Init
		PARAMETERS nTop, nLeft
		IF PCOUNT() > 0
		   THIS.Top  = nTop
		   THIS.Left = nLeft
		ENDIF
	ENDPROC


	PROCEDURE MouseEnter
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		THIS.BackColor = THIS.ActiveColor
		IF THIS.Name = [Bar]
		   RETURN
		ENDIF
		IF nXCoord <= THIS.Left OR nXCoord >= ( THIS.Left + THIS.Width )
		   RETURN
		ENDIF
		WITH THISFORM
		.LockScreen = .T.
		WITH .JavaMenu1
		.X = THIS.Top
		.Y = THIS.Left + THIS.Width
		.ShowMenu ( VAL ( RIGHT ( THIS.Name, 1 ) ) )
		ENDWITH
		.LockScreen = .F.
		ENDWITH
	ENDPROC


	PROCEDURE MouseLeave
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		THIS.BackColor = THIS.InactiveColor
	ENDPROC


ENDDEFINE